package sync4j.foundation.engine.source;

import sync4j.framework.engine.SyncItemKey;

import java.sql.Timestamp;

/**
 * Class that stores information on a SyncItem
 */
public class SyncItemInfo {

    // -------------------------------------------------------------- Properties

    /**
     *
     */
    private Timestamp lastModified;


    /**
     *
     */
    private SyncItemKey key;


    /**
     * @return Timestamp
     */
    public Timestamp getLastModified() {
        return lastModified;
    }

    /**
     * @param lastModified Timestamp
     */
    public void setLastModified(Timestamp lastModified) {
        this.lastModified = lastModified;
    }

    /**
     * @return SyncItemKey
     */
    public SyncItemKey getKey() {
        return key;
    }

    /**
     * @param key SyncItemKey
     */
    public void setKey(SyncItemKey key) {
        this.key = key;
    }

    /**
     * @param key String
     */
    public void setKey(String key) {
        this.key = new SyncItemKey(key);
    }

    // ------------------------------------------------------------ Constructors

    /**
     *
     */
    public SyncItemInfo() {
    }


    /**
     * @param sKey         String
     * @param lastModified Timestamp
     */
    public SyncItemInfo(String sKey, Timestamp lastModified) {
        this.key = new SyncItemKey(sKey);
        this.lastModified = lastModified;
    }

    /**
     * @param key          SyncItemKey
     * @param lastModified Timestamp
     */
    public SyncItemInfo(SyncItemKey key, Timestamp lastModified) {
        this.key = key;
        this.lastModified = lastModified;
    }


}
