package sync4j.zimbra.items.model;

import zimbra.soap.util.ContactDetails;

import java.util.HashMap;
import java.util.Set;


public class ContactProperties {

    // -------------------------------------------------------- Public Constants
    // zimbra contact table columns

    //Identity details
    public static final String K_UID = ContactDetails.K_ID;
    public static final String K_MODIFICATION_DATE = ContactDetails.K_MODIFICATION_DATE;
    public static final String K_FIRST_NAME = ContactDetails.K_FIRST_NAME;
    public static final String K_MIDDLE_NAME = ContactDetails.K_MIDDLE_NAME;
    public static final String K_LAST_NAME = ContactDetails.K_LAST_NAME;
    public static final String K_NOTE = ContactDetails.K_NOTES;

    //Personal Details
    public static final String K_PD_ADDRESS_STATE = ContactDetails.K_HOME_STATE;
    public static final String K_PD_ADDRESS_CODE = ContactDetails.K_HOME_POSTAL_CODE;
    public static final String K_PD_ADDRESS_CITY = ContactDetails.K_HOME_CITY;
    public static final String K_PD_ADDRESS_COUNTRY = ContactDetails.K_HOME_COUNTRY;
    public static final String K_PD_ADDRESS_STREET = ContactDetails.K_HOME_STREET;
    public static final String K_PD_WEBPAGE = ContactDetails.K_HOME_URL;
    public static final String K_PD_OTHERWEBPAGE = ContactDetails.K_OTHER_URL;
    public static final String K_PD_EMAIL1 = ContactDetails.K_EMAIL;
    public static final String K_PD_EMAIL2 = ContactDetails.K_EMAIL2;
    public static final String K_PD_PHONE1 = ContactDetails.K_OTHER_PHONE;
    public static final String K_PD_PHONE2 = ContactDetails.K_MOBILE_PHONE;
    public static final String K_PD_PHONE3 = ContactDetails.K_HOME_PHONE;
    public static final String K_PD_PHONE4 = ContactDetails.K_HOME_PHONE2;
    public static final String K_PD_PHONE5 = ContactDetails.K_HOME_FAX;
    public static final String K_PD_OADDRESS_STATE = ContactDetails.K_OTHER_STATE;
    public static final String K_PD_OADDRESS_CODE = ContactDetails.K_OTHER_POSTAL_CODE;
    public static final String K_PD_OADDRESS_CITY = ContactDetails.K_OTHER_CITY;
    public static final String K_PD_OADDRESS_COUNTRY = ContactDetails.K_OTHER_COUNTRY;
    public static final String K_PD_OADDRESS_STREET = ContactDetails.K_OTHER_STREET;
    public static final String K_PD_OTHER_FAX = ContactDetails.K_OTHER_FAX;
    //Business Details
    public static final String K_BD_ADDRESS_STATE = ContactDetails.K_WORK_STATE;
    public static final String K_BD_ADDRESS_CODE = ContactDetails.K_WORK_POSTAL_CODE;
    public static final String K_BD_ADDRESS_CITY = ContactDetails.K_WORK_CITY;
    public static final String K_BD_ADDRESS_COUNTRY = ContactDetails.K_WORK_COUNTRY;
    public static final String K_BD_ADDRESS_STREET = ContactDetails.K_WORK_STREET;
    public static final String K_BD_WEBPAGE = ContactDetails.K_WORK_URL;
    public static final String K_BD_TITLE = ContactDetails.K_JOB_TITLE;
    public static final String K_BD_PHONE1 = ContactDetails.K_WORK_PHONE;
    public static final String K_BD_PHONE2 = ContactDetails.K_WORK_PHONE2;
    public static final String K_BD_PHONE3 = ContactDetails.K_WORK_FAX;
    public static final String K_BD_EMAIL = ContactDetails.K_EMAIL3;
    public static final String K_BD_ASSISTANT = ContactDetails.K_ASSISTAINT_PHONE;
    public static final String K_BD_COMPANY = ContactDetails.K_COMPANY;


    /*
        UNUSED ZIMBRA CONTACT DETAILS
        -----------------------------
        ContactDetails.K_CALLBACK_PHONE
        ContactDetails.K_CAR_PHONE;
        ContactDetails.K_COMPANY_PHONE
        ContactDetails.K_PAGER
        ContactDetails.K_FILE_AS
    */

    public static final String[] keysArray = new String[]
    {
        K_UID, K_FIRST_NAME, K_MIDDLE_NAME, K_LAST_NAME, K_NOTE,
        K_PD_ADDRESS_STATE, K_PD_ADDRESS_CODE, K_PD_ADDRESS_CITY, K_PD_ADDRESS_COUNTRY
    };

    private HashMap contact = null;

    public ContactProperties() {
        this.contact = new HashMap();
    }

    public ContactProperties(HashMap values) {
        contact = values;
    }

    public void put(Object key, Object value) {
        this.contact.put(key, value);
    }

    public void remove(Object key) {
        this.contact.remove(key);
    }

    public Object get(Object key) {
        return this.contact.get(key);
    }


    public String getUniversalID() {
        return (String) this.get(K_UID);
    }

    public int size() {
        return this.contact.size();
    }

    public Set getKeys() {
        return this.contact.keySet();
    }

    public HashMap getHashMap() {
        return this.contact;
    }
}

