package sync4j.zimbra.items.model;

import zimbra.soap.util.CalendarDetails;

import java.util.HashMap;
import java.util.Set;


public class MeetingProperties {

    // -------------------------------------------------------- Public Constants
    // sugar contact table columns
    public static final String K_ID                = CalendarDetails.K_ID;

    public static final String K_ORGANIZER         = CalendarDetails.K_ORGANIZER;
    public static final String K_NAME              = CalendarDetails.K_NAME;
    public static final String K_LOCATION          = CalendarDetails.K_LOCATION;
    public static final String K_FREE_BUSSY        = CalendarDetails.K_FREE_BUSSY;
    public static final String K_ACTUAL_FREE_BUSSY = CalendarDetails.K_ACTUAL_FREE_BUSSY;
    public static final String K_STATUS            = CalendarDetails.K_STATUS;
    public static final String K_TRANSPARENCY      = CalendarDetails.K_TRANSPARENCY;
    public static final String K_ALL_DAY           = CalendarDetails.K_ALL_DAY;

    public static final String K_DATETIME_START = CalendarDetails.K_START_DATETIME;
    public static final String K_DATETIME_END   = CalendarDetails.K_END_DATETIME;
    public static final String K_TIMEZONE       = CalendarDetails.K_TIMEZONE;    
    public static final String K_RECURENCE      = CalendarDetails.K_RECURRENCE;

    public static final String K_ADDRESS         = CalendarDetails.K_ADDRESS;
    public static final String K_FRIENDLY_NAME    = CalendarDetails.K_FRIENDLY_NAME;



    // -------------------------------------------------------------- Properties

    private CalendarDetails calendar = null;


    // ------------------------------------------------------------- Constructor

    public MeetingProperties() {
        this.calendar = new CalendarDetails();
    }

    public MeetingProperties(HashMap values) {
        calendar = new CalendarDetails(values);
    }

    // ---------------------------------------------------------- Public Methods

    public void put(Object key, Object value) {
        this.calendar.put(key, value);
    }

    public void remove(Object key) {
        this.calendar.remove(key);
    }

    public Object get(Object key) {
        return this.calendar.get(key);
    }

    public String getUniversalID() {
        return (String) this.get(K_ID);
    }

    public int size() {
        return this.calendar.size();
    }

    public Set getKeys() {
        return this.calendar.keySet();
    }

    public HashMap getHashMap()
    {
        return this.calendar;
    }

}

