package sync4j.zimbra.util;

/**
 * Copyright (C) 2005 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

import sync4j.framework.engine.SyncItem;
import sync4j.framework.tools.Base64;


/**
 * <p>Utility class</p>
 *
 * @author Gilberto Migliavacca
 * @version $Id: Utility.java 395 2006-06-27 17:27:17Z harrie $
 */

public class Utility {

    // ------------------------------------------------------------ Public Methods

    /**
     * Returns the password taking it from the given credentials (in base64)
     * knowing the username.
     * <p>The credential format is:  b64("username:password")
     *
     * @param username    String
     * @param credentials String
     * @return password String
     */
    public static String getPassword(String username, String credentials) {
        String up = new String(Base64.decode(credentials));
        int l = username.length();
        String password;
        password = up.substring(l + 1, up.length());
        return password;
    }


    /**
     * Converts the given object in a empty string if it's <code>null</code>
     * or "null", otherwise returns the given object string represetation.
     *
     * @param obj Object
     * @return String
     */
    public static String nullToVoid(Object obj)
    {
        if ((obj == null) || obj.toString().equalsIgnoreCase("null")) return " ";
        return obj.toString();
    }

    /**
     * get content from a SyncItem
     */
    public static String getContentFromSyncItem(SyncItem syncItem,
                                                boolean isEncode) {
        String content;

        // get content of the item

        byte[] itemContent = (byte[]) syncItem.getPropertyValue(SyncItem.PROPERTY_BINARY_CONTENT);
        if (itemContent == null) {
            itemContent = new byte[0];
        }
        content = new String(itemContent);
        if (isEncode &&
                content.length() > 0) {
            content = new String(Base64.decode(content));
        }

        return content;
    }
}
