package zimbra.soap;

import zimbra.soap.util.FolderDetails;

import java.util.List;
import java.util.LinkedList;

import org.xml.sax.SAXException;
import org.xml.sax.Attributes;

//handler for the parsing of the GetFolderResponse XML
public class GetFolderResponseHandler
extends ResponseHandler
{
    private List foldersList = null;

    public void startElement(String uri, String localName,
                             String qName,
                             Attributes attributes)
    throws SAXException
    {
        super.startElement(uri, localName, qName, attributes);
        String eName = "".equals(localName)?qName:localName;
        if("GetFolderResponse".equals(eName))
        {
            foldersList = new LinkedList();
            return;
        }
        if("folder".equals(eName))
        {
            FolderDetails folderDetails = new FolderDetails();
            folderDetails.put(FolderDetails.K_ID,
                              attributes.getValue(FolderDetails.K_ID));
            folderDetails.put(FolderDetails.K_NAME,
                              attributes.getValue(FolderDetails.K_NAME));
            foldersList.add(folderDetails);
        }
    }

    public Object[] getOutcome()
    {
        if(foldersList == null) return new FolderDetails[0];
        return foldersList.toArray(new FolderDetails[0]);
    }
}
