package zimbra.soap.request.contact;

import zimbra.soap.request.SOAPRequest;
import zimbra.soap.util.ContactDetails;

import java.util.LinkedList;
import java.util.Iterator;

/**
 * Wrapper for the GetContactsRequest soap request
 */
public class GetContactsRequest
    implements SOAPRequest
{

    private LinkedList attrs = new LinkedList();
    private LinkedList ids   = new LinkedList();
    private boolean useFilter;

    public GetContactsRequest()
    {
        this.useFilter = false;
    }

    public GetContactsRequest(boolean useFilter)
    {
        this.useFilter = useFilter;
    }

    public GetContactsRequest(Object [] attrs, Object [] ids)
    {
        for(int i=0; i<attrs.length; i++)
            this.attrs.add(attrs[i]);
        for(int i=0; i<ids.length; i++)
            this.attrs.add(ids[i]);
        this.useFilter = true;
    }

    public void addAttribute(Object attr)
    {
        for(int i=0; i<ContactDetails.keysArray.length; i++)
            if(attr.equals(ContactDetails.keysArray[i])){
                this.attrs.add(attr);
                break;
            }
    }

    public void addId(Object id)
    {
        this.ids.add(id);
    }

    public Object[] getAtrributes()
    {
        return this.attrs.toArray();
    }

    public Object[] getIds()
    {
        return this.ids.toArray();
    }

    public void setUseFilter(boolean useFilter)
    {
        this.useFilter = useFilter;
    }

    public boolean getUseFilter()
    {
        return this.useFilter;
    }

    public String toXML()
    {
        if(!this.useFilter) return "<GetContactsRequest xmlns=\"urn:zimbraMail\"/>";
        StringBuffer toReturn = new StringBuffer();
        toReturn.append("<GetContactsRequest xmlns=\"urn:zimbraMail\">");
        Iterator attrsIter = this.attrs.iterator();
        while(attrsIter.hasNext())
        {
            toReturn.append("<a n=\"");
            toReturn.append(attrsIter.next().toString());
            toReturn.append("\"/>");
        }
        Iterator idsIter   = this.ids.iterator();
        while(idsIter.hasNext())
        {
            toReturn.append("<cn id=\"");
            toReturn.append(idsIter.next().toString());
            toReturn.append("\"/>");
        }

        toReturn.append("</GetContactsRequest>");
        return toReturn.toString();
    }
}
