package zimbra.soap.response;

import java.util.HashMap;

/**
 * class for handeling the information that comes out of a GetAccountInfoReasponse
 * from Zimbra server
 */

public class AccountInfoResponse
{
        /**
         * keys that one should use if one wants to construct the object
         * out of a HashMap
         */
        public static final String K_NAME             = "name";
        public static final String K_ZIMBRA_ID        = "zimbraId";
        public static final String K_ZIMBRA_MAIL_HOST = "zimbraMailHost";

        /**
         * private member,
         * important information of a GetAccountInfoResponse
         */
        private HashMap members = null;

        protected AccountInfoResponse()
        {

        }

        /**
         * constructor
         *
         * @param hm HashMap
         */

        public AccountInfoResponse(HashMap hm)
        {
            this.members = hm;
        }


        public String getName()
        {
            return (String)this.members.get(AccountInfoResponse.K_NAME);
        }

        public String getZimbraId() {
            return (String)this.members.get(AccountInfoResponse.K_ZIMBRA_ID);
        }


        public String getZimbraMailHost() {
            return (String)this.members.get(AccountInfoResponse.K_ZIMBRA_MAIL_HOST);
        }

        public String toString() {
            return this.getName() + " " + this.getZimbraId() + " " + this.getZimbraMailHost();
        }
    }