package zimbra.soap.response;

import java.util.HashMap;

public class AuthResponse {
    /**
     * keys that one should use if one wants to construct the object
     * out of a HashMap
     */
    public static final String K_AUTH_TOKEN = "authToken";
    public static final String K_LIFETIME = "lifetime";
    public static final String K_SESSION_ID = "sessionID";
    public static final String K_TIME_ZONE = "timeZone";

    /**
     * private member, HashMap storing the information of an AuthResponse
     */

    private HashMap members;


    protected AuthResponse() {

    }

    public AuthResponse(HashMap hm) {
        this.members = hm;
    }

    public String getAuthToken() {
        return (String) this.members.get(AuthResponse.K_AUTH_TOKEN);
    }

    public String getLifetime() {
        return (String) this.members.get(AuthResponse.K_LIFETIME);
    }

    public String getSessionId() {
        return (String) this.members.get(AuthResponse.K_SESSION_ID);
    }

    public String toString() {
        return this.getAuthToken() + " " + this.getLifetime() + " " + this.getSessionId();
    }
}