package zimbra.soap.response;

/**
 * Created by IntelliJ IDEA.
 * User: adeac
 * Date: Nov 30, 2005
 * Time: 4:39:47 PM
 * To change this template use File | Settings | File Templates.
 */

import org.xml.sax.SAXException;
import org.xml.sax.Attributes;
import org.xml.sax.helpers.DefaultHandler;

public class SOAPBodyHandler extends DefaultHandler {

    private boolean foundBodyStart;
    private boolean foundBodyEnd;

    public SOAPBodyHandler() {

    }

    public void startDocument()
            throws SAXException {
        foundBodyStart = false;
        foundBodyEnd = false;
    }

    public void endDocument()
            throws SAXException {
        if (!this.foundBodyStart || !this.foundBodyEnd) {
            throw new SAXException("SOAP body doesn't exist or is Broken!");
        }
    }

    public void startElement(String uri,
                             String localName,
                             String qName,
                             Attributes attrs)
            throws SAXException {
        String eName = localName;
        if ("".equals(eName)) eName = qName;
        if ("soap:Body".equals(eName)) {
            this.foundBodyStart = true;
        }
    }

    public void endElement(String uri,
                           String localName,
                           String qName)
            throws SAXException {
        String eName = localName;
        if ("".equals(eName)) eName = qName;
        if ("soap:Body".equals(eName)) {
            this.foundBodyEnd = true;
        }
    }

    public boolean getFoundBodyStart() {
        return this.foundBodyStart;
    }

    public boolean getFoundBodyEnd() {
        return this.foundBodyEnd;
    }

    public void characters()
            throws SAXException {
    }

}
