package zimbra.soap.util;

import java.util.HashMap;

public class CalendarDetails extends ItemDetails
{
    //KEYS
    public static final String K_DEFUALT_INV_ID        = "inv_id";
    public static final String K_COMP_NUM              = "compNum";
    public static final String K_TYPE                  = "type";
    public static final String K_STATUS                = "status";
    public static final String K_FREE_BUSSY            = "fb";
    public static final String K_ACTUAL_FREE_BUSSY     = "fba";
    public static final String K_TRANSPARENCY          = "transp";
    public static final String K_ALL_DAY               = "allDay";
    public static final String K_NAME                  = "name";
    public static final String K_LOCATION              = "loc";
    public static final String K_TIMEZONE              = "tz";
    public static final String K_START_DATETIME        = "s";
    public static final String K_END_DATETIME          = "e";
    public static final String K_ORGANIZER             = "or";
    public static final String K_ATTENDEES             = "at";
    public static final String K_RECURRENCE            = "recur";

    //KEYS FOR ORGANIZER AND ATTENDEES
    public static final String K_ADDRESS               = "a";
    public static final String K_FRIENDLY_NAME         = "d";
    //KEYS FOR ATTENDEES
    public static final String K_ATTENDEE_ROLE         = "role";
    public static final String K_ATTENDEE_PTST         = "ptst";

    //POSSIBLE VALUES
    public static final String V_ATTENDEE_ROLE_CHAIR          = "CHA";
    public static final String V_ATTENDEE_ROLE_REQUIRED       = "REQ";
    public static final String V_ATTENDEE_ROLE_OPTIONAL       = "OPT";
    public static final String V_ATTENDEE_ROLE_NONPARTICIPANT = "NON";
    public static final String V_ATTENDEE_ROLE_RESOURCE       = "RES";

    public static final String V_ATTENDEE_PTST_NEEDS_ACTION = "NE";
    public static final String V_ATTENDEE_PTST_TENTATIVE    = "TE";
    public static final String V_ATTENDEE_PTST_ACCEPT       = "AC";
    public static final String V_ATTENDEE_PTST_DECLINE      = "DE";
    public static final String V_ATTENDEE_PTST_DELEGATED    = "DG";
    public static final String V_ATTENDEE_PTST_COMPLETED    = "CO";
    public static final String V_ATTENDEE_PTST_INPROCESS    = "IN";

    protected static final String[] keysArray = new String[]
    {
            K_TYPE, K_STATUS, K_FREE_BUSSY, K_ACTUAL_FREE_BUSSY, K_TRANSPARENCY,
            K_ALL_DAY, K_NAME, K_LOCATION, K_TIMEZONE, K_START_DATETIME, K_END_DATETIME,
            K_ORGANIZER, K_ATTENDEES, K_RECURRENCE
    };

    protected static final Object DEFAULT_TYPE              = "event";
    protected static final Object DEFAULT_STATUS            = "CONF";
    protected static final Object DEFAULT_FREE_BUSSY        = "B";
    protected static final Object DEFAULT_ACTUAL_FREE_BUSSY = "B";
    protected static final Object DEFAULT_TRANSPARENCY      = "O";
    protected static final Object DEFAULT_ALL_DAY           = "0";
    protected static final Object DEFAULT_NAME              = null;
    protected static final Object DEFAULT_LOCATION          = "";
    protected static final Object DEFAULT_TIMEZONE          = "";
    protected static final Object DEFAULT_START_DATETIME    = null;
    protected static final Object DEFAULT_END_DATETIME      = null;
    protected static final Object DEFAULT_ORGANIZER         = null;
    protected static final Object DEFAULT_ATTENDEES         = null;
    protected static final Object DEFAULT_RECURRENCE        = null;

    protected static final Object[] defaultValues = new Object[]
    {
            DEFAULT_TYPE, DEFAULT_STATUS, DEFAULT_FREE_BUSSY,
            DEFAULT_ACTUAL_FREE_BUSSY, DEFAULT_TRANSPARENCY, DEFAULT_ALL_DAY, DEFAULT_NAME,
            DEFAULT_LOCATION, DEFAULT_TIMEZONE, DEFAULT_START_DATETIME, DEFAULT_END_DATETIME,
            DEFAULT_ORGANIZER, DEFAULT_ATTENDEES, DEFAULT_RECURRENCE
    };

    public CalendarDetails()
    {
        super();
        for(int i=0; i<keysArray.length; i++)
            this.put(keysArray[i], defaultValues[i]);
    }

    public CalendarDetails(HashMap hm)
    {
        super(hm);
        for(int i=0; i<keysArray.length; i++)
            if(hm.containsKey(keysArray[i]))
                this.put(keysArray[i],
                         hm.get(keysArray[i]));
            else
                this.put(keysArray[i],
                         defaultValues[i]);
    }
}
