package zimbra.soap.util;

import sync4j.zimbra.util.Def;

import java.util.HashMap;
import java.util.logging.Logger;

public class ContactDetails extends HashMap {
    public static final String K_CALLBACK_PHONE = "callbackPhone";
    public static final String K_OTHER_COUNTRY = "otherCountry";
    public static final String K_JOB_TITLE = "jobTitle";
    public static final String K_HOME_POSTAL_CODE = "homePostalCode";
    public static final String K_HOME_CITY = "homeCity";
    public static final String K_HOME_STATE = "homeState";
    public static final String K_OTHER_STATE = "otherState";
    public static final String K_ASSISTAINT_PHONE = "assistantPhone";
    public static final String K_FIRST_NAME = "firstName";
    public static final String K_WORK_CITY = "workCity";
    public static final String K_COMPANY = "company";
    public static final String K_MOBILE_PHONE = "mobilePhone";
    public static final String K_HOME_URL = "homeURL";
    public static final String K_WORK_STREET = "workStreet";
    public static final String K_HOME_PHONE2 = "homePhone2";
    public static final String K_WORK_PHONE2 = "workPhone2";
    public static final String K_HOME_STREET = "homeStreet";
    public static final String K_MIDDLE_NAME = "middleName";
    public static final String K_WORK_COUNTRY = "workCountry";
    public static final String K_EMAIL2 = "email2";
    public static final String K_WORK_FAX = "workFax";
    public static final String K_PAGER = "pager";
    public static final String K_WORK_PHONE = "workPhone";
    public static final String K_OTHER_STREET = "otherStreet";
    public static final String K_OTHER_URL = "otherURL";
    public static final String K_EMAIL3 = "email3";
    public static final String K_NOTES = "notes";
    public static final String K_HOME_PHONE = "homePhone";
    public static final String K_OTHER_CITY = "otherCity";
    public static final String K_WORK_STATE = "workState";
    public static final String K_LAST_NAME = "lastName";
    public static final String K_HOME_COUNTRY = "homeCountry";
    public static final String K_OTHER_PHONE = "otherPhone";
    public static final String K_OTHER_POSTAL_CODE = "otherPostalCode";
    public static final String K_HOME_FAX = "homeFax";
    public static final String K_OTHER_FAX = "otherFax";
    public static final String K_COMPANY_PHONE = "companyPhone";
    public static final String K_EMAIL = "email";
    public static final String K_FILE_AS = "fileAs";
    public static final String K_WORK_URL = "workURL";
    public static final String K_WORK_POSTAL_CODE = "workPostalCode";
    public static final String K_CAR_PHONE = "carPhone";

    public static final String K_ID = "id";
    public static final String K_MODIFICATION_DATE = "md";
    public static final String K_TAGS = "t";
    public static final String K_FLAGS = "f";
    public static final String K_FOLDER = "l";
    public static final String K_CHAGE_TOKEN = "rev";

    public static Object[] keysArray = new Object[]
    {
        K_CALLBACK_PHONE, K_OTHER_COUNTRY, K_JOB_TITLE,
        K_HOME_POSTAL_CODE, K_HOME_CITY, K_HOME_STATE, K_OTHER_STATE,
        K_ASSISTAINT_PHONE, K_FIRST_NAME, K_WORK_CITY, K_COMPANY,
        K_MOBILE_PHONE, K_HOME_URL, K_WORK_STREET, K_HOME_PHONE2,
        K_WORK_PHONE2, K_HOME_STREET, K_MIDDLE_NAME, K_WORK_COUNTRY,
        K_EMAIL2, K_WORK_FAX, K_PAGER, K_WORK_PHONE, K_OTHER_STREET,
        K_OTHER_URL, K_EMAIL3, K_NOTES, K_HOME_PHONE, K_OTHER_CITY,
        K_WORK_STATE, K_LAST_NAME, K_HOME_COUNTRY, K_OTHER_PHONE,
        K_OTHER_POSTAL_CODE, K_HOME_FAX, K_OTHER_FAX, K_COMPANY_PHONE,
        K_EMAIL, K_FILE_AS, K_WORK_URL, K_WORK_POSTAL_CODE, K_CAR_PHONE,
        K_ID, K_MODIFICATION_DATE, K_TAGS, K_FLAGS, K_FOLDER
    };

    /**
     * fields supported by Nokia
     */
    public static Object[] nokia6600KeysArray = new Object[]
    {
        K_OTHER_COUNTRY, K_JOB_TITLE,
        K_HOME_POSTAL_CODE, K_HOME_CITY, K_HOME_STATE, K_OTHER_STATE,
        K_FIRST_NAME, K_WORK_CITY, K_COMPANY,
        K_MOBILE_PHONE, K_HOME_URL, K_WORK_STREET,
        K_HOME_STREET, K_MIDDLE_NAME, K_WORK_COUNTRY,
        K_EMAIL2, K_WORK_FAX, K_WORK_PHONE, K_OTHER_STREET,
        K_OTHER_URL, K_EMAIL3, K_NOTES, K_HOME_PHONE, K_OTHER_CITY,
        K_WORK_STATE, K_LAST_NAME, K_HOME_COUNTRY, K_OTHER_PHONE,
        K_OTHER_POSTAL_CODE, K_HOME_FAX, K_OTHER_FAX,
        K_EMAIL, K_FILE_AS, K_WORK_URL, K_WORK_POSTAL_CODE,
        K_ID, K_MODIFICATION_DATE, K_TAGS, K_FLAGS, K_FOLDER
    };

    /**
     * fields supported by SE P900
     */
    public static Object[] seP900KeysArray = new Object[]
    {
        K_JOB_TITLE,
        K_HOME_POSTAL_CODE, K_HOME_CITY, K_HOME_STATE,
        K_FIRST_NAME, K_WORK_CITY, K_COMPANY,
        K_MOBILE_PHONE, K_WORK_STREET,
        K_HOME_STREET, K_MIDDLE_NAME, K_WORK_COUNTRY,
        K_EMAIL2, K_WORK_FAX, K_WORK_PHONE,
        K_OTHER_URL, K_EMAIL3, K_NOTES, K_HOME_PHONE,
        K_WORK_STATE, K_LAST_NAME, K_HOME_COUNTRY, K_OTHER_PHONE,
        K_HOME_FAX, K_OTHER_FAX,
        K_EMAIL, K_FILE_AS, K_WORK_URL, K_WORK_POSTAL_CODE,
        K_ID, K_MODIFICATION_DATE, K_TAGS, K_FLAGS, K_FOLDER
    };

    /**
     * fields supported by Motorola V3 RAZR
     */
    public static Object[] motorolaV3KeysArray = new Object[]
    {
        K_FIRST_NAME, K_LAST_NAME,
        K_EMAIL, K_EMAIL2,
        K_WORK_FAX, K_WORK_PHONE,
        K_MOBILE_PHONE,
        K_HOME_PHONE, K_HOME_FAX,
        K_OTHER_FAX,
        K_ID, K_MODIFICATION_DATE, K_TAGS, K_FLAGS, K_FOLDER
    };

    /**
     * fields supported by Motorola V400
     */
    public static Object[] motorolaV400KeysArray = new Object[]
    {
        K_FIRST_NAME, K_LAST_NAME,
        K_EMAIL, K_EMAIL2,
        K_WORK_PHONE,
        K_MOBILE_PHONE,
        K_HOME_PHONE, K_HOME_FAX,
        K_OTHER_FAX,
        K_ID, K_MODIFICATION_DATE, K_TAGS, K_FLAGS, K_FOLDER
    };

    /**
     * fields supported by default
     */
    public static Object[] defaultKeysArray = new Object[]
    {
        K_FIRST_NAME, K_LAST_NAME,
        K_EMAIL, K_EMAIL2,
        K_WORK_PHONE2,
        K_WORK_FAX, K_WORK_PHONE,
        K_MOBILE_PHONE, K_HOME_PHONE2,
        K_HOME_PHONE, K_HOME_FAX,
        K_OTHER_PHONE,
        K_OTHER_FAX,
        K_ID, K_MODIFICATION_DATE, K_TAGS, K_FLAGS, K_FOLDER
    };

    /**
     * BlackBerry keysArray
     */
    public static Object[] blackBerryKeysArray = new Object[]
    {
        K_JOB_TITLE,
        K_FIRST_NAME, K_COMPANY,
        K_MOBILE_PHONE,
        K_WORK_FAX, K_WORK_PHONE,
        K_NOTES,
        K_LAST_NAME, K_OTHER_PHONE,
        K_EMAIL, K_FILE_AS,
        K_ID, K_MODIFICATION_DATE, K_TAGS, K_FLAGS, K_FOLDER
    };

    public ContactDetails() {
        super();
    }

    public ContactDetails(HashMap hm) {
        super();
        if (hm == null) return;
        for (int i = 0; i < keysArray.length; i++)
            if (hm.containsKey(keysArray[i]))
                this.put(keysArray[i], hm.get(keysArray[i]));
    }

    public String getCreateClause(String phone) {
        Object[] keys;
        StringBuffer sb = new StringBuffer();
        if (phone.equalsIgnoreCase(Def.NOKIA_6600))
            keys = nokia6600KeysArray;
        else if (phone.equalsIgnoreCase(Def.SE_P900))
            keys = seP900KeysArray;
        else if (phone.equalsIgnoreCase(Def.MOTOROLA_RAZR))
            keys = motorolaV3KeysArray;
        else if (phone.equalsIgnoreCase(Def.MOTOROLA_V400))
            keys = motorolaV3KeysArray;
        else if (phone.equalsIgnoreCase(Def.BLACKBERRY))
            keys = blackBerryKeysArray;
        else if (phone.equalsIgnoreCase(Def.POCKET_PC))
            keys = keysArray;
        else
            keys = defaultKeysArray;

        for (int i = 0; i < keys.length - 5; i++) {
            sb.append("<a n=\"");
            sb.append(keys[i]);
            sb.append("\">");
            if (this.get(keys[i]) != null && ((String) this.get(keys[i])).length() > 0)
                sb.append((String) this.get(keys[i]));
            else
                sb.append("   ");
            sb.append("</a>");
        }
        return sb.toString();
    }
}
