package zimbra.soap.util;

import java.util.HashMap;

public class RecurenceDetails extends HashMap {
    public static final String K_ADD_EXCLUDE = "add_exclude";
    public static final String K_DATETIME_START = "date";
    public static final String K_TIMEZONE = "tz";
    public static final String K_RULE_FREQUENCY = "freq";
    public static final String K_RULE_DATETIME_END = "until";
    public static final String K_RULE_COUNT = "count";
    public static final String K_RULE_INTERVAL = "interval";
    public static final String K_RULE_BYSECOND = "bysecond";
    public static final String K_RULE_BYMINUTE = "byminute";
    public static final String K_RULE_BYHOUR = "byhour";
    public static final String K_RULE_BYDAY = "byday";
    public static final String K_RULE_BYDAY_ORDWK = "ordwk";
    public static final String K_RULE_BYDAY_DAY = "day";
    public static final String K_RULE_BYMONTHDAY = "bymonthday";
    public static final String K_RULE_BYYEARDAY = "byyearday";
    public static final String K_RULE_BYWEEKNO = "byweekno";
    public static final String K_RULE_BYMONTH = "bymonth";
    public static final String K_RULE_BYSETPOS = "bysetpos";
    public static final String K_RULE_WKST = "wkst";

    public RecurenceDetails() {
        super();
    }

    public String toString() {
        String add_exclude = (String) this.get(K_ADD_EXCLUDE);
        String timeZone = (String) this.get(K_TIMEZONE);
        String date = (String) this.get(K_DATETIME_START);
        String freq = (String) this.get(K_RULE_FREQUENCY);
        String until = (String) this.get(K_RULE_DATETIME_END);
        String count = (String) this.get(K_RULE_COUNT);
        String interval = (String) this.get(K_RULE_INTERVAL);
        //String[] bySecond   = (String[]) this.get(K_RULE_BYSECOND);
        //String[] byMinute   = (String[]) this.get(K_RULE_BYMINUTE);
        //String[] byHour     = (String[]) this.get(K_RULE_BYHOUR);
        HashMap[] byDay = (HashMap[]) this.get(K_RULE_BYDAY);
        String[] byMonthDay = (String[]) this.get(K_RULE_BYMONTHDAY);
        // String[] byYearDay  = (String[]) this.get(K_RULE_BYYEARDAY);
        //String[] byWeekNo   = (String[]) this.get(K_RULE_BYWEEKNO);
        String[] byMonth = (String[]) this.get(K_RULE_BYMONTH);
        //String[] bySetPos   = (String[]) this.get(K_RULE_BYSETPOS);
        //String[] wkst       = (String[]) this.get(K_RULE_WKST);


        StringBuffer xml = new StringBuffer();
        if (add_exclude != null) {
            xml.append("<").append(this.get(K_ADD_EXCLUDE)).append(">");
            if (date != null)
                xml.append("<date d=\"").append(date).append("\" tz=\"").
                        append(nullToVoid(timeZone)).append("\"/>");
            if (freq != null) xml.append("<rule freq=\"").append(freq).append("\">");
            if (until != null)
                xml.append("<until d=\"").append(until).append("\" tz=\"").
                        append(nullToVoid(timeZone)).append("\"/>");
            if (count != null) xml.append("<count num=\"").append(count).append("\"/>");
            if (interval != null) xml.append("<interval ival=\"").append(interval).append("\"/>");

            if (byDay != null && byDay.length > 0) {
                xml.append("<byday>");
                for (int i = 0; i < byDay.length; i++) {
                    String day = (String) byDay[i].get(K_RULE_BYDAY_DAY);
                    String ordwk = (String) byDay[i].get(K_RULE_BYDAY_ORDWK);
                    xml.append("<wkday ");
                    if (ordwk != null) xml.append("ordwk=\"").append(ordwk).append("\" ");
                    xml.append("day=\"").append(nullToVoid(day)).append("\"/>");
                }
                xml.append("</byday>");
            }

            if (byMonthDay != null && byMonthDay.length > 0) {
                xml.append("<bymonthday modaylist=\"");
                for (int i = 0; i < byMonthDay.length; i++) {
                    if (i > 0) xml.append(",");
                    xml.append(byMonthDay[i]);

                }
                xml.append("\"/>");
            }

            if (byMonth != null && byMonth.length > 0) {
                xml.append("<bymonth molist=\"");
                for (int i = 0; i < byMonth.length; i++) {
                    if (i > 0) xml.append(",");
                    xml.append(byMonth[i]);

                }
                xml.append("\"/>");
            }

            if (freq != null) xml.append("</rule>");
            xml.append("</").append(add_exclude).append(">");
        }
        return xml.toString();
    }

    private static Object nullToVoid(Object obj) {
        if (obj == null && "null".equals(obj))
            return "";
        else
            return obj;
    }

}
