--
-- Initialization data for the Sync4j Zimbra Connector module
--
-- @author Alexandru Deac
-- @version 1.0
--

--  workaround to delete mysql FK 


create table ss_item_status
(
 source_uri varchar(100),
 principal varchar(100),
 id varchar(100),
 last_modified timestamp(14)
);


create table sync4j_last_sync
(
  principal   integer not null,
  sync_source varchar(128) not null,
  last_anchor_server varchar(20),
  last_anchor_client varchar(20),
  start_sync  datetime,
  end_sync    datetime,

  constraint pk_sync4j_last_sync primary key (principal, sync_source)
);



create table sync4j_client_mapping
(
  principal   integer not null,
  sync_source varchar(100) not null,
  luid        varchar(120) not null,
  guid        varchar(120) not null,
  
  constraint pk_clientmapping primary key (principal, sync_source, luid, guid)
);


create table sync4j_principal
(
  username    varchar(32 ) not null,
  device      varchar(128) not null,
  id          integer      not null,
  
  constraint pk_sync4j_principal primary key (id)
);
