--
-- Initialization data for the Sync4j Zimbra Connector module
--
-- @author Alexandru Deac
-- @version 1.0
--
--
-- Source registration
--
delete from sync4j_sync_source_type where id='zimbra-calendar-1.0';
insert into sync4j_sync_source_type(id, description, class, admin_class) values('zimbra-calendar-1.0','Zimbra Calendar SyncSource','sync4j.zimbra.engine.source.ZimbraCalendarSyncSource','sync4j.zimbra.admin.ZimbraSyncSourceConfigPanel');

delete from sync4j_sync_source_type where id='zimbra-contact-1.0';
insert into sync4j_sync_source_type(id, description, class, admin_class) values('zimbra-contact-1.0','Zimbra Contact SyncSource','sync4j.zimbra.engine.source.ZimbraContactSyncSource','sync4j.zimbra.admin.ZimbraSyncSourceConfigPanel');


delete from sync4j_module where id='zimbra-1.0';
insert into sync4j_module (id, name, description) values('zimbra-1.0','zimbra-1.0','Sync4j Zimbra Connector 1.0');

delete from sync4j_connector where id='zimbra-1.0';
insert into sync4j_connector(id, name, description, admin_class) values('zimbra-1.0','Sync4j Zimbra Connector','Sync4j Zimbra Connector','');

delete from sync4j_connector_source_type where connector='zimbra-1.0' and (sourcetype='zimbra-calendar-1.0' or sourcetype='zimbra-contact-1.0');
insert into sync4j_connector_source_type(connector, sourcetype) values('zimbra-1.0','zimbra-calendar-1.0');
insert into sync4j_connector_source_type(connector, sourcetype) values('zimbra-1.0','zimbra-contact-1.0');

delete from sync4j_module_connector where module='zimbra-1.0' and connector='zimbra-1.0';
insert into sync4j_module_connector(module, connector) values('zimbra-1.0','zimbra-1.0');



--  workaround to delete mysql FK 

--
-- SYNC4J_PRINCIPAL
--
insert into sync4j_principal (id, username, device)
  values('1', 'guest', 'syncml-phone');
  
insert into sync4j_principal (id, username, device)
  values('2', 'guest', 'sc-pim-demo');

insert into sync4j_principal (id, username, device)
  values('3', 'guest','sc-pim-outlook');
  
insert into sync4j_principal (id, username, device)
  values('4', 'guest','sc-pim-blackberry');
  
insert into sync4j_principal (id, username, device)
  values('5', 'guest','sc-pim-palm');

insert into sync4j_principal (id, username, device)
  values('6', 'guest','sc-pim-ppc');

insert into sync4j_principal (id, username, device)
  values('7', 'guest','sc-api-j2se');

insert into sync4j_principal (id, username, device)
  values('8', 'guest','sc-api-j2me');

insert into sync4j_principal (id, username, device)
  values('9', 'guest','sc-api-nat');

insert into sync4j_principal (id, username, device)
  values('10', 'guest','sc-pim-ipod');
